var choiceMenuItemsExt;
var selectedItemExt;
var selectedNodeId;
var choiceNodeInfos = {};

// Is model opened, boolean flag set to true
// after checkIfModelIsOpen() returns "yes"
var isModelOpen = false;
var numberOfTimesIsModelOpenedCalled = 0;

////////////////////////////////////////////////////
//
// onLoad
//
// When page is loaded.  Initial idea is to sign in and open the model.
// If page is reloaded and the model is already open, then don't reopen.
//
function onLoad(event) {
  //alert("onLoad - " + event)
  //alert("onloadd");
  //checkIfModelIsOpen();
  //getUserInput("Target_year");
}

/////////////////////////////////////////////////////
//
// signInAcp
//
// Calls ACP's LoginV3 web service.
//
function signInAcp(email, pass, subscriptionName) {
  // update status text
  // document.getElementById('status').innerHTML =  "Signing into ACP...";

  // build the soap request string
  var soapSigninRequest = addSoapEnvelop(
    `<LoginV3 xmlns="http://tempuri.org/"><id>${email}</id><pass>${pass}</pass><subscriptionName>${subscriptionName}</subscriptionName></LoginV3>`
  );

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();

  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        var handleErrorResult = handleSoapErrorIfPresent(xmlhttp);
        if (handleErrorResult == "no error present") {
          // after signing open the model if it's not already open
          openModelAcp("AMPERE 0.53.ana", "", "true");
        }
      }
    }
  };

  // send the soap request
  xmlhttp.send(soapSigninRequest);
}

/////////////////////////////////////////////////////
//
// checkIfModelIsOpen
//
// Calls ACP's IsModelOpen web service.  Will be used initially
// by User input extension.
//
function checkIfModelIsOpen() {
  // update status text
  // document.getElementById('status').innerHTML =  "Signing into ACP...";

  // build the soap request string
  var soapSigninRequest = addSoapEnvelop(
    `<IsModelOpen xmlns="http://tempuri.org/"></IsModelOpen>`
  );

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();

  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        // res will be "yes" or "no"
        let res = xmlhttp.responseXML.getElementsByTagName(
          "IsModelOpenResult"
        )[0].innerHTML;

        //alert(res + "!!");

        // increment numberOfTimesIsModelOpenedCalled
        numberOfTimesIsModelOpenedCalled++;
        if (res === "no") {
          if (numberOfTimesIsModelOpenedCalled < 10) {
            setTimeout(checkIfModelIsOpen, 2000);
            // update status text
            let statusTextDiv = document.getElementById("statusTextDiv");
            statusTextDiv.innerHTML = "Waiting for model to open";
            let j = 0;
            for (j = 0; j < numberOfTimesIsModelOpenedCalled; j++)
              statusTextDiv.innerHTML += ".";
          } else {
            let statusTextDiv = document.getElementById("statusTextDiv");
            statusTextDiv.innerHTML = "Timed out.  Refresh to try again.";
          }
        } else {
          // set isModleOpen flag
          isModelOpen = true;

          //alert(tableau.extensions.settings.get("variableId"));
          //alert(tableau.extensions.settings.get("doesNotExist"));

          // gett he variableId if saved
          const mapWorksheetName = tableau.extensions.settings.get(
            "mapWorksheetName"
          );

          // if 'variableId' not set, then show form for setting it.
          //alert(tableau.extensions.settings.get("variableId"));
          if (mapWorksheetName === undefined) {
            // show the form for setting variableId
            document.getElementById("formContainer").style.display = "inline";

            // hide fields and variable id inputs and set button
            document.getElementById("fields").style.display = "none";
            document.getElementById("fieldsLabel").style.display = "none";
            document.getElementById("variableId").style.display = "none";
            document.getElementById("variableIdLabel").style.display = "none";
            document.getElementById("setButton").style.display = "none";
            document.getElementById("fieldsToDisplayLabel").style.display =
              "none";
            document.getElementById("fieldstodisplay").style.display = "none";

            // and hide status text
            document.getElementById("statusTextDiv").style.display = "none";

            // Get the dashboard
            var dashboard = tableau.extensions.dashboardContent.dashboard;

            // build list of worksheets options for pulldown
            var i;
            let options = `<option value="">Select map worksheet</option>`;
            for (i = 0; i < dashboard.worksheets.length; i++) {
              var worksheet = dashboard.worksheets[i];
              let selected = "";
              //if (selectedItem === projectsArray[j].innerHTML)
              //  selected = " selected";

              //alert(worksheet.name);
              let option = `<option value="${worksheet.name}"${selected}>${worksheet.name}</option>`;
              options += option;
            }

            // add the options to the select tag i.e. pulldown menu
            document.getElementById("worksheets").innerHTML = options;
          } else {
            // add selection handler....
            //
            // Get the worksheet object we want to get the selected marks for
            // and add an event listener for changes to selected node
            const worksheet = getSelectedSheet(mapWorksheetName);

            // Add an event listener for the selection changed event on this sheet.
            unregisterEventHandlerFunction = worksheet.addEventListener(
              tableau.TableauEventType.MarkSelectionChanged,
              mapSelectionChangeHandler
            );
            //alert(
            // "unregisterEventHandlerFunction " + unregisterEventHandlerFunction
            //);

            // show table with info on selected location
            //showTable();

            // remove any status text
            clearAllStatusText();
          }
        }
      }
    }
  };

  // send the soap request
  xmlhttp.send(soapSigninRequest);
}

/////////////////////////////////////////////////////
//
// mapSelectionChangeHandler
//
// This function is called when someone clicks on a new map
// location.  The function displays and/or updates the table
// with the location info data from nodes.csv.
// Then updates the definition of selected_node_id (or whatever)
// and updates the graphs.
function mapSelectionChangeHandler(selectionEvent) {
  // show table with info on selected location
  //alert("selectionEvent");
  //showTable();

  // When the selection changes, reload the data
  //alert(updateSelectedNodeId);
  //alert(tableau.extensions.settings.get("mapWorksheetName"));
  updateSelectedNodeId(tableau.extensions.settings.get("mapWorksheetName"));
}

function updateSelectedNodeId(worksheetName) {
  // Remove any existing event listeners
  //if (unregisterEventHandlerFunction) {
  //  unregisterEventHandlerFunction();
  //}

  // Get the worksheet object we want to get the selected marks for
  const worksheet = getSelectedSheet(worksheetName);

  // Set our title to an appropriate value
  //$('#selected_marks_title').text(worksheet.name);

  // Call to get the selected marks for our sheet
  worksheet.getSelectedMarksAsync().then(function(marks) {
    // Get the first DataTable for our selected marks (usually there is just one)
    const worksheetData = marks.data[0];

    //alert(worksheetData.data[0][2].value);
    //selectedNodeId = worksheetData.data[0][2].value;
    //alert(selectedNodeId);

    const varId = tableau.extensions.settings.get("variableId");

    updateVariableDefinition(varId, "'" + worksheetData.data[0][2].value + "'");

    // show busy feedback i.e. model with hourglass
    $("#myModal").modal("show");
  });
}

/////////////////////////////////////////////////////
//
// getDiagramInputs
//
// Calls ACP's getDiagramInputs web service.  And then handles the result by creating
// html for the inputs.
//
function getDiagramInputs(modId, modelId) {
  // update status text
  // document.getElementById('status').innerHTML =  "Signing into ACP...";

  // build the soap request string
  var soapSigninRequest = addSoapEnvelop(
    `<GetDiagramInputs xmlns="http://tempuri.org/"><modId>${modId}</modId><modelId>${modelId}</modelId></GetDiagramInputs>`
  );

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();

  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        var handleErrorResult = handleSoapErrorIfPresent(xmlhttp);
        if (handleErrorResult == "no error present") {
          //
          //alert('break here');
          //makeChoiceSelect([20,30,40], 1)

          var resXml = xmlhttp.responseXML;
          var nodeDrawingObjects = resXml.getElementsByTagName(
            "NodeDrawingObject"
          );

          let i = 0;
          for (; i < nodeDrawingObjects.length; i++) {
            // get id of the original node which will be used to update the variable's definition
            const defOriginal = nodeDrawingObjects[i].getElementsByTagName(
              "defOriginal"
            )[0].innerHTML;

            let choicePosition = defOriginal.toLowerCase().indexOf("choice(");
            //alert(defOriginal);
            //alert(choicePosition);

            if (choicePosition === -1) {
              insertTextUserInput(nodeDrawingObjects[i]);
            } else {
              insertChoiceUserInput(nodeDrawingObjects[i]);
            }

            // adds a spacer between inputs
            let acpUserInputs = document.getElementById("acpUserInputs");
            acpUserInputs.innerHTML += `<div
			  style="background-color:white;width: 200px;height:5px; font-size: 10pt;padding: 1px;"
			></div>`;
          }
        }
      }
    }
  };

  // send the soap request
  xmlhttp.send(soapSigninRequest);
}

/////////////////////////////////////////////////////
//
// getUserInput
//
// Calls ACP's GetUserInput web service.  And then handles the result by creating
// html for the inputs.
//
// variableId is the id of the origial node
//
function getUserInput(variableId) {
  // update status text
  // document.getElementById('status').innerHTML =  "Signing into ACP...";

  // build the soap request string
  var soapRequest = addSoapEnvelop(
    `<GetUserInput xmlns="http://tempuri.org/"><variableId>${variableId}</variableId></GetUserInput>`
  );

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();

  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        var handleErrorResult = handleSoapErrorIfPresent(xmlhttp);
        if (handleErrorResult == "no error present") {
          //
          //alert('break here');
          //makeChoiceSelect([20,30,40], 1)

          var resXml = xmlhttp.responseXML;
          var nodeDrawingObjects = resXml.getElementsByTagName("nodeObject");

          let i = 0;
          for (; i < nodeDrawingObjects.length; i++) {
            // get id of the original node which will be used to update the variable's definition
            const defOriginal = nodeDrawingObjects[i].getElementsByTagName(
              "defOriginal"
            )[0].innerHTML;

            let choicePosition = defOriginal.toLowerCase().indexOf("choice(");
            //alert(defOriginal);
            //alert(choicePosition);

            if (choicePosition === -1) {
              insertTextUserInput(nodeDrawingObjects[i]);
            } else {
              insertChoiceUserInput(nodeDrawingObjects[i]);
            }

            // hide status text
            document.getElementById("statusTextDiv").style.display = "none";
          }
        }
      }
    }
  };

  // send the soap request
  xmlhttp.send(soapRequest);
}

//////////////////////////////////////
//
// insertTextUserInput
//
// Adds a terxt input corresponding to a text user input from the model.
//
function insertTextUserInput(nodeDrawingObject) {
  // get the inputs title
  const inputTitle = nodeDrawingObject.getElementsByTagName("nodetitle")[0]
    .innerHTML;

  // get id of the original node which will be used to update the variable's definition
  const nodeidOriginal = nodeDrawingObject.getElementsByTagName(
    "nodeidOriginal"
  )[0].innerHTML;

  // get id of the original node which will be used to update the variable's definition
  const defOriginal = nodeDrawingObject.getElementsByTagName("defOriginal")[0]
    .innerHTML;
  // alert(defOriginal);

  let myParent = document.getElementById("acpUserInputs");
  //alert(myParent + " " + myParent.innerHTML);
  myParent.innerHTML =
    myParent.innerHTML +
    `${inputTitle}<br /><input id="${nodeidOriginal}" type="text" value="${defOriginal}" onchange="onChangeTextInput(event)" />`;
}

//////////////////////////////////////
//
// insertChoiceUserInput
//
// Adds a terxt input corresponding to a text user input from the model.
//
function insertChoiceUserInput(nodeDrawingObject) {
  // get the inputs title
  const inputTitle = nodeDrawingObject.getElementsByTagName("nodetitle")[0]
    .innerHTML;

  // get id of the original node which will be used to update the variable's definition
  const nodeidOriginal = nodeDrawingObject.getElementsByTagName(
    "nodeidOriginal"
  )[0].innerHTML;

  // get id of the original node which will be used to update the variable's definition
  const defOriginal = nodeDrawingObject.getElementsByTagName("defOriginal")[0]
    .innerHTML;

  //alert(defOriginal);

  // let's store the definition in an associative array
  choiceNodeInfos[nodeidOriginal] = defOriginal;

  // get the selected index for the choice menu
  const selectedIndex = nodeDrawingObject.getElementsByTagName(
    "SelectedIndex"
  )[0].innerHTML;

  //
  // get the menu items
  //
  const choiceListItems = nodeDrawingObject.getElementsByTagName(
    "ChoiceListItem"
  );

  let i;
  let options = "";
  for (i = 0; i < choiceListItems.length; i++) {
    let selected = "";
    if (selectedIndex == i) selected = " selected";

    let option = `<option value="${
      choiceListItems[i].getElementsByTagName("data")[0].innerHTML
    }"${selected}>${
      choiceListItems[i].getElementsByTagName("label")[0].innerHTML
    }</option>`;

    options += option;
  }

  // build the select tag (i.e. choice pulldown) html

  let myParent = document.getElementById("acpUserInputs");
  //alert(myParent + " " + myParent.innerHTML);
  myParent.innerHTML =
    myParent.innerHTML +
    `${inputTitle}<br />
	  <select id="${nodeidOriginal}" onchange="onChangeChoiceInput(event)" 
		>${options}
	  </select>
	</div>`;
}

//////////////////////////////////////
//
// handleSoapErrorIfPresent
//
// When acp soap web service calls return they will have a Messages object if
// an error occurred.  This function will display that message and more...
//
// Returns:
//
// If there is an error, then returns 'error present'.  If no error, then returns 'no error present'.
function handleSoapErrorIfPresent(soapResponse) {
  var resXml = soapResponse.responseXML;
  var successXml = resXml.getElementsByTagName("Messages");
  var result = "no error present";
  if (successXml.length != 0) {
    // looks there is an message (almost always an Error message) present

    // for now just elect the 'text' of the error message
    alert(
      "Error: " +
        successXml[0].childNodes[0].childNodes[0].childNodes[1].innerHTML
    );
    result = "Error present";
  }

  return result;
}
//////////////////////////////////////
//
//  openModelAcp
//
//
// Calls ACP open model web service.
//
// Parameters
//
// modelFileName - name of model e.g. Bond Model.ana
// folderNumber - folder number used in ACP, often this can be left blank
// closeOpenModel - if ACP is already playing a model, thie boolean say whether or not to open the model anyways.  Set this
// to either 'true' or 'false' (text value)
//
function openModelAcp(modelFileName, folderNumber, closeOpenModel) {
  // build the soap request string
  var soapRequest = addSoapEnvelop(
    `<OpenModelV3AndAHalf xmlns="http://tempuri.org/"><modelFileName>${modelFileName}</modelFileName><folderIdNumber /><closeOpenModel>${closeOpenModel}</closeOpenModel><urlId></urlId><subscriptionName>Lumina</subscriptionName></OpenModelV3AndAHalf>`
  );
  //alert(soapRequest);

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();

  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        var handleErrorResult = handleSoapErrorIfPresent(xmlhttp);
        if (handleErrorResult == "no error present") {
          // update status text
          let statusTextDiv = document.getElementById("statusTextDiv");
          statusTextDiv.innerHTML += "<br>Model opened.";

          // load the user inputs from the specified module in the model
          getDiagramInputs("Price_Projections", "Price_analysis");
        }
      }
    }
  };

  // send the soap request
  xmlhttp.send(soapRequest);
}

///////////////////////////////////////////////////////////////////////
//
// updateVariableDefinition
//
//
// This function will call ACP's web service for updating a variables definition.  Can be used with text inputs,
// checkboxes, choice inputs etc.
//
// Initially, just have two parameters.
// - variableId
// - newDefinition
function updateVariableDefinition(variableId, newDefinition) {
  // get the name of the dashboard so we can pass it to ACP server and set
  // the module to use for updating output node results
  const dashboardName = tableau.extensions.dashboardContent.dashboard.name;

  //alert(dashboardName);

  // build the soap request string
  var soapRequest = addSoapEnvelop(
    `<tns:UpdateNodeDef xmlns:tns="http://tempuri.org/"><tns:theNodeId>${variableId}</tns:theNodeId><tns:newDef>${newDefinition}</tns:newDef><tns:formnodeId>module:${dashboardName}</tns:formnodeId><tns:clickDateTime></tns:clickDateTime></tns:UpdateNodeDef>`
  );

  alert(soapRequest);

  // update status text
  /*
  let statusTextDiv = document.getElementById("statusTextDiv");
  statusTextDiv.innerHTML = "Updating results.  Please wait...";
  */

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();

  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        // remove busy model dialog after a brief moment
        setTimeout(() => {
          $("#myModal").modal("hide");
        }, 5);

        alert(xmlhttp.responseText);
        var handleErrorResult = handleSoapErrorIfPresent(xmlhttp);
        if (handleErrorResult == "no error present") {
          // update status text
          /*showStatusBriefly(
            "New results computed. Updating dashbaord worksheets...",
            3
          );*/

          //
          // Refresh affected worksheets with new model result data from csv files
          //

          // get the names for the sheets that need updating from web service result
          const worksheetNames = xmlhttp.responseXML.getElementsByTagName(
            "idsOfCsvFilesWritten"
          )[0].children;

          for (let j = 0; j < worksheetNames.length; j++) {
            //alert(worksheetNames[j].innerHTML);

            let worksheet = getSelectedSheet(worksheetNames[j].innerHTML);

            //alert(worksheet);

            if (worksheet != undefined) {
              var dataSourcesPromise = worksheet.getDataSourcesAsync();
              dataSourcesPromise.then(
                arrayOfDataSources => {
                  var refreshAsyncPromise = arrayOfDataSources[0].refreshAsync();
                  refreshAsyncPromise.then(
                    refreshAsyncResolvedHandler,
                    refreshAsyncResolvedErrorHandler
                  );
                },
                errorObj => {
                  alert(
                    "getDataSourcesAsync() promised hit an error. " +
                      errorObj.toString()
                  );
                }
              );
            }
          }
        }
      }
    }
  };

  // send the soap request
  xmlhttp.send(soapRequest);
}

function refreshAsyncResolvedHandler(p1, p2) {
  //alert("refreshAsyncResolvedHandler");
}

function refreshAsyncResolvedErrorHandler(p1, p2) {
  //alert("refreshAsyncResolvedErrorHandler");
}

////////////////////////////////////////////////////////////////////////
//
//  onChangeChoiceInput
//
// Change handler for choice inputs (i.e. html select pulldowns).
// Will call UpdateNodeDef
function onChangeChoiceInput(event) {
  //alert("onChangeInput " + event.target.id);
  //alert("old def " + choiceNodeInfos[event.target.id]);

  //
  // update choice() definition
  //
  let newChoiceSecondParameter = event.target.value;
  let newChoiceDef = "";
  let oldChoiceDefintion = choiceNodeInfos[event.target.id];

  // code from actionscript flex, we can use for handling subtable choices
  //
  //if (this.nodeFields.isSubChoice != "true")
  //  strs = this.nodeFields.defOriginal.split(",");
  //else strs = this.nodeFields.subTableChoiceDef.split(",");

  let splitChoiceArray = oldChoiceDefintion.split(",");
  splitChoiceArray[1] = newChoiceSecondParameter;
  newChoiceDef = splitChoiceArray.join(",");

  // so strs.length will be 2 if the choice node only has two parameters.
  // In that case we need to add closing paren
  if (splitChoiceArray.length == 2) newChoiceDef += ")";

  alert("new choice def " + newChoiceDef);
  updateVariableDefinition(event.target.id, newChoiceDef);
}

////////////////////////////////////////////////////////////////////////
//
//  onChangeTextInput
//
// Change handler for choice inputs (i.e. html select pulldowns).
// Will call UpdateNodeDef
function onChangeTextInput(event) {
  alert("onChangeTextInput " + event.target.value);
  updateVariableDefinition(event.target.id, event.target.value);
}

/*
//////////////////////////////////////
//
//  getListofMenuItems
//
//  Calls Typescript web service.  Gets the list of items for the choice pulldown.
//
function getListofMenuItems() {
  // build the soap request string
  var soapRequest = addSoapEnvelop(
    '<tns:TypeScript xmlns:tns="http://tempuri.org/"><tns:command>Definition dashboard_index</tns:command></tns:TypeScript>'
  );
  //alert(soapRequest);

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();
  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        //alert(xmlhttp.responseText);

        // extract the list of menu items and store in choiceMenuItemsExt
        var resXml = xmlhttp.responseXML;
        var successXml = resXml.getElementsByTagName("TypeScriptResult")[0];
        choiceMenuItemsExt = successXml.childNodes[0].nodeValue;

        // get the selected item
        document.getElementById("status").innerHTML +=
          " Menu items are " +
          choiceMenuItemsExt +
          ".<br>Getting selected item for pulldown...";
        getSelectedItem();
      }
    }
  };

  // Send the Soap request as a POST
  xmlhttp.send(soapRequest);
}

//////////////////////////////////////
//
//  getSelectedItem
//
//  Calls Typescript web service.  Gets the selected item for the choice pulldown.
//
function getSelectedItem() {
  // build the soap request string
  var soapRequest = addSoapEnvelop(
    '<tns:TypeScript xmlns:tns="http://tempuri.org/"><tns:command>mid(Dashboard_selection)</tns:command></tns:TypeScript>'
  );
  //alert(soapRequest);

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();
  xmlhttp.send(soapRequest);

  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        var resXml = xmlhttp.responseXML;
        var successXml = resXml.getElementsByTagName("TypeScriptResult")[0];
        selectedItemExt = successXml.childNodes[0].nodeValue;
        document.getElementById("status").innerHTML +=
          " The selected item is " +
          selectedItemExt +
          ".<br><br>REFRESH VIEW and then change pulldown menu.";
        makeChoiceSelect(eval(choiceMenuItemsExt), selectedItemExt);
      }
    }
  };
}
*/

function addSoapEnvelop(soapRequestWithoutEnvelop) {
  var soapRequestWithEnvelop =
    '<?xml version="1.0" encoding="utf-8"?><SOAP-ENV:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body>';
  soapRequestWithEnvelop +=
    soapRequestWithoutEnvelop + "</SOAP-ENV:Body></SOAP-ENV:Envelope>";
  return soapRequestWithEnvelop;
}

/////////////////////////////////////////////////////////////
//
// getXMLHttpRequest
//
// small helper function which sets up the xmlhttpObject and then returns that object.
function getXMLHttpRequest() {
  var xmlhttpObject = new XMLHttpRequest();
  let url = "https://tableau-dev.analytica.com:8112/acp/AcpService.asmx";
  //url = "http://localhost:12340/AcpService.asmx";
  xmlhttpObject.open("POST", url, true);
  xmlhttpObject.setRequestHeader("Content-Type", "text/xml");
  return xmlhttpObject;
}

////////////////////////////////////////////////////////////////
//
// makeChoiceSelect
//
// Makes an html select item i.e. a pulldown menu like a choice input
function makeChoiceSelect(items, selectedIndex) {
  //var myParent = document.body;
  var myParent = document.getElementById("choiceInputDiv");

  //Create array of options to be added
  var array = items;

  //Create and append select list
  var selectList = document.createElement("select");
  selectList.id = "mySelect";
  myParent.appendChild(selectList);

  //Create and append the options
  for (var i = 0; i < array.length; i++) {
    var option = document.createElement("option");
    option.value = array[i];
    option.text = array[i];
    selectList.appendChild(option);
  }

  selectList.selectedIndex = 1;
  selectList.onchange = onChoiceChange;
}

/////////////////////////////////////////////////////////////////////
//
// onChoiceChange
//
// The onchange event handler for the choice pulldown menu.
//
function onChoiceChange() {
  //alert('onChoiceChange');

  var selList = document.getElementById("mySelect");
  var newDefinition = "";
  if (selList.selectedIndex == 1)
    newDefinition = "dashboard_selection: Choice(Dashboard_index,2,0)";
  else newDefinition = "dashboard_selection: Choice(Dashboard_index,1,0)";
  //alert(newDefinition);
  //sr = '<?xml version="1.0" encoding="utf-8"?><SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:s="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><SOAP-ENV:Body><tns:TypeScript xmlns:tns="http://tempuri.org/"><tns:command>' + newDefinition + '</tns:command></tns:TypeScript></SOAP-ENV:Body></SOAP-ENV:Envelope>';

  // build the soap request string
  var soapRequest = addSoapEnvelop(
    '<tns:TypeScript xmlns:tns="http://tempuri.org/"><tns:command>' +
      newDefinition +
      "</tns:command></tns:TypeScript>"
  );
  //alert(soapRequest);

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();

  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        // Get the dashboard
        var dashboard = tableau.extensions.dashboardContent.dashboard;

        // Display the name of dashboard in the UI
        //alert("db name" + dashboard.name);

        // get teh only worksheet
        var worksheet = dashboard.worksheets[0];

        // the example code I saw says if I want to call refreshAsyn worked like this...
        var dataSourcesPromise = worksheet.getDataSourcesAsync();
        //dataSourcesPromise.then(getDataSourcesAsyncCallBack);
        dataSourcesPromise.then(
          arrayOfDataSources => {
            arrayOfDataSources[0].refreshAsync();
          },
          errorObj => {
            alert(
              "getDataSourcesAsync() promised hit an error. " +
                errorObj.toString()
            );
          }
        );
      }
    }
  };

  // send the soap request
  xmlhttp.send(soapRequest);
}

function getDataSourcesAsyncCallBack(arrayOfDataSources) {
  // get the only datasource and call refreshAsync()
  arrayOfDataSources[0].refreshAsync();
}
